/*
 *  $Id: demo.c,v 1.7 2000/12/03 15:55:06 tgkamp Exp $
 *
 *  picoTK demo App. 
 *
 *  Copyright (c) by Thomas Gallenkamp <tgkamp@users.sourceforge.net>
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#define VERSION "$Id: demo.c,v 1.7 2000/12/03 15:55:06 tgkamp Exp $"

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <math.h>
#include "PTK.h"
     
extern struct picoPixmap pixmap_pengo;
extern int volatile Clock_driver_ticks;
struct picoTerminal term1;


void mudelay(int); 
unsigned char *fbuf;

#define ESC_BLUE      "\e[31m"
#define ESC_GREEN     "\e[32m"
#define ESC_CYAN      "\e[33m"
#define ESC_RED       "\e[34m"
#define ESC_MAGENTA   "\e[35m"
#define ESC_YELLOW    "\e[36m"
#define ESC_WHITE     "\e[37m"
#define ESC_BRIGHT    "\e[38m"
#define ESC_BLACK     "\e[30m"
#define ESC_BG_WHITE  "\e[47m"
#define ESC_BG_BLACK  "\e[40m"
#define ESC_UP        "\e[A"
#define ESC_DOWN      "\e[B"
#define ESC_RIGHT     "\e[C"
#define ESC_LEFT      "\e[D"
#define DOT_LEFT "*" ESC_LEFT ESC_LEFT
#define DOT_UP   "*" ESC_LEFT ESC_UP
#define DOT_DOWN "*" ESC_LEFT ESC_DOWN
#define DOT_RIGHT "*"

char termtxt[]="This is text printed\r\n"
               "continously into a\r\n"
               "picoTK terminal box.\r\n"
               "\r\n"
               "Using term boxes with\r\n"
               "picoTK is really easy.\r\n"
               "You simply have to print"
               "the text using\r\n"
               ESC_BRIGHT
               "   picoTermPrintf()\r\n"
               ESC_WHITE
               "Just as with an ordinary"
               "printf().\r\n"
               "\r\n"
               "You can have certain\r\n"
               "VT100/VT320 escape\r\n"
               "sequences to control\r\n"
               "things.\r\n"
               "\r\n"
               "Such as emphasizing\r\ntext:\r\n"
               ESC_RED "red " ESC_WHITE ESC_GREEN "green " 
               ESC_WHITE  ESC_BLUE "blue " ESC_YELLOW "yellow" "\r\n"
               ESC_MAGENTA "magenta " ESC_CYAN "cyan\r\n"
               ESC_BRIGHT "    extra bright" "\r\n" ESC_WHITE
               "\r\n"
               "You can move the cursor\r\n"
               "around...\r\n\n\n  like here...\n\n\n"
               ESC_UP 
               DOT_LEFT DOT_LEFT DOT_LEFT DOT_LEFT 
               DOT_LEFT DOT_LEFT DOT_LEFT DOT_LEFT
               DOT_LEFT DOT_LEFT DOT_LEFT DOT_LEFT
               DOT_LEFT DOT_LEFT 
               DOT_UP DOT_UP DOT_UP DOT_UP 
               DOT_RIGHT DOT_RIGHT DOT_RIGHT DOT_RIGHT
               DOT_RIGHT DOT_RIGHT DOT_RIGHT DOT_RIGHT
               DOT_RIGHT DOT_RIGHT DOT_RIGHT DOT_RIGHT
               DOT_RIGHT DOT_RIGHT 
               DOT_DOWN DOT_DOWN DOT_DOWN DOT_DOWN
               "\n\n\n"
               "\r\n"
               "Best of all you can have"
               "an arbitrary number\r\n"
               "of term boxes on the\r\n"
               "same screen\r\n"
               "\r\n"
               "This text is artifically"
               "delayed by printing one\r\n"
               "character at a time and\r\n"
               "sleeping for 50ms\r\n"
               "\r\n"
               "picoTK is a small foot-\r\n"
               "print GUI toolkit. \r\n"
               "Depending on the number\r\n"
               "and size of fonts\r\n"
               "included it requires\r\n"
               "only a few KBytes.\r\n"
               "\r\n\n\n\n";


void demo_circle() {
    struct picoGC gc;

    int i,j,k;
    int x,y;
    int n;
   #define PI 3.141596
   #define XA(x) sin( (float) (((float)x)/n*2)*PI)*150+480
   #define YA(x) cos( (float) (((float)x)/n*2)*PI)*150+160

    picoCreateGC(&gc);
    picoSetForeground(&gc,15);
    picoSetFont(&gc,&font_helv_m20);
    picoDrawTextCentered(&gc,480,312,"Demo 1: Drawing Lines");
    for (k=0; k<8; k++) {
    n=5+2*k;
    picoSetForeground(&gc,k+8);
    for (i=0; i<n; i++) {
      x=XA(i); y=YA(i);
      for (j=i; j<n; j++) {
        picoDrawLine(&gc,x,y,XA(j),YA(j));
        mudelay(10);
      }
     }
    {
     char *txt;
     int txt_h;
       int txt_w;

     picoSetFont(&gc,&font_helv_b34);
     txt="picoTK !";
     txt_h=picoTextHeight(&font_helv_b34,txt);
     txt_w=picoTextWidth(&font_helv_b34,txt); 
     picoSetForeground(&gc,picoInfoColorDepth()==1 ?0:8);
     picoFillRect(&gc,480-(txt_w*80)/100,160-(txt_h*80)/100,
                 (txt_w*160)/100,(txt_h*160)/100);
     picoDrawRect(&gc,480-(txt_w*2)/3,160-(txt_h*2)/3,
                 txt_w*4/3,txt_h*4/3);
     picoSetForeground(&gc,10);
     picoSetBackground(&gc,picoInfoColorDepth()==1 ?0:8);
     picoDrawText(&gc,480-txt_w/2,160-txt_h/2,txt);
     picoSetBackground(&gc,0);
     picoDrawRect(&gc,480-(txt_w*2)/3,160-(txt_h*2)/3,
                 txt_w*4/3,txt_h*4/3);
     mudelay(2000);
     }
    picoSetForeground(&gc,0);
    picoFillRect(&gc,328,0,312,310);
    picoSetForeground(&gc,7);
    }
    picoSetForeground(&gc,0);
    picoFillRect(&gc,328,0,312,334);
    picoSetForeground(&gc,7);

}

void demo_meter_fmt(char *buf, char *pre, float a) { 
   sprintf(buf,"%s %04d.%03d mm",pre,(int)a,(int)((a-floor(a))*1000.0));
}

void demo_meter() {
    struct picoGC gc;

    int k;
    int xs,ys;
    int ypos;
    char buf[15];

    picoCreateGC(&gc);
    picoSetForeground(&gc,15);
    picoSetFont(&gc,&font_helv_m20);
    picoDrawTextCentered(&gc,480,312,"Demo 2: Pretty big fonts");
    
    picoSetForeground(&gc,7);
    picoSetFont(&gc,&font_helv_b34);
    demo_meter_fmt(buf,"X: ",0.0);
    ys=picoTextHeight(gc.font,buf)+80;
    xs=picoTextWidth(gc.font,buf);
    ypos=320+160-xs/2;
    
    picoDrawRect(&gc,ypos-2,48,xs+4,ys+4);
    picoDrawRect(&gc,ypos-3,47,xs+6,ys+6);
    for (k=0; k<200; k++) {
     demo_meter_fmt(buf,"X: ",12.5+sin(k*0.01)*10);
     ys=picoTextHeight(gc.font,buf)*3;
     xs=picoTextWidth(gc.font,buf);
     ypos=320+160-xs/2;
     picoDrawText(&gc,ypos, 50,buf);
     demo_meter_fmt(buf,"Y: ",12.5+cos(k*0.01)*10);
     picoDrawText(&gc,ypos, 90,buf);
     demo_meter_fmt(buf,"Z: ",3.5+sin(k*0.05)*3);
     picoDrawText(&gc,ypos,130,buf);

     mudelay(100);
    }
    picoSetForeground(&gc,0);
    picoFillRect(&gc,328,0,312,334);
    picoSetForeground(&gc,7);
}

void demo_pixmap() {
    struct picoGC gc;

    int i,j;

    picoCreateGC(&gc);
    picoSetForeground(&gc,15);
    picoSetFont(&gc,&font_helv_m20);
    picoDrawTextCentered(&gc,480,312,"Demo 3: Two color Pixmap");
    picoSetFont(&gc,&font_8x13);

    for (j=1; j<15; ) {
     picoSetForeground(&gc,j++);
     for (i=0; i<100; i++) {
      picoDrawPixmap(&gc,390+i,80,&pixmap_pengo);
      mudelay(20);
     }
     if (picoInfoColorDepth()>1) {
      picoSetForeground(&gc,j++);
      for (; i>=0; i--) {
       picoDrawPixmap(&gc,390+i,80,&pixmap_pengo);
       mudelay(picoInfoColorDepth()>1 ? 20:100);
      }
     } else {
      j=16;
     }

    }
    mudelay(1000);
    picoSetForeground(&gc,0);
    picoFillRect(&gc,321,0,319,334);
    picoSetForeground(&gc,7);
}

void demo_colors() {
    struct picoGC gc;

    int i,j;

    picoCreateGC(&gc);
    picoSetForeground(&gc,15);
    picoSetFont(&gc,&font_helv_m20);
    picoDrawTextCentered(&gc,480,312,"Demo 4: Available colors");
    picoSetFont(&gc,&font_8x13);

    for (j=0; j<16; j++) {
     for (i=0; i<16; i++) {
       int xo, yo,col;
       char buf[10];
       xo=345+i*17;
       yo=10+j*17;
       col=i+j*16;
       sprintf(buf,"%02X",col);
       picoSetForeground(&gc,col);
       picoFillRect(&gc,xo,yo,16,16);
       picoSetForeground(&gc,col==0 ? 15:0);
       picoSetBackground(&gc,col);
       picoDrawText(&gc,xo,yo+1,buf);
     }
    }

    mudelay(20000);
    picoSetForeground(&gc,0);
    picoFillRect(&gc,321,0,319,334);
    picoSetForeground(&gc,7);
}

void ptk_demo2(void) {
  while(1) {
      demo_circle();
      demo_meter();
      demo_pixmap();
      if (picoInfoColorDepth()>1) demo_colors();
  }
}

void demo_draw_lines() {
    unsigned char *ptr;
    int fd;
    float a;
    struct picoGC gc;

    int len=32768;
    int i;

    a=2.25;
    picoCreateGC(&gc);
    picoSetForeground(&gc,7);
    picoDrawRect(&gc,0,0,320,240);
    picoDrawRect(&gc,2,2,316,236);
    picoDrawRect(&gc,4,4,312,232);

     picoSetFont(&gc,&font_helv_m20);
    {
        picoSetFont(&gc,&font_helv_m20);
        picoDrawTextCentered(&gc,56,150,"picoTK !\npowered by\nRTEMS 4.5");
        picoSetFont(&gc,&font_helv_m20);
        picoDrawText(&gc,335,340,"These demos show RTEMS exec-\n"
                             "uting two timesliced preempting\n"
                             "tasks:\n"
                             " - Task 1: Scrollable terminal box\n"
                             " - Task 2: Graphics demos");
        picoSetFont(&gc,&font_5x7);
        picoDrawText(&gc,335,470,VERSION);                      
    } 

    picoSetForeground(&gc,14);
    picoSetBackground(&gc,0);
    picoDrawPixmap(&gc,8,8,&pixmap_pengo);
    picoSetFont(&gc,&font_5x7);
    picoSetForeground(&gc,7);
    picoDrawTextCentered(&gc,61,128,"embedded 2 col pic\n(Linux Pengo)");
    picoSetFont(&gc,&font_6x12);
    picoDrawTextCentered(&gc,112+96,8,"Scrollable Term box using 8x13 font");
    picoSetFont(&gc,&font_8x13);
    picoTerminalCreate(&term1,&gc,112,20,24,16);
    picoDrawRect(&gc,term1.x-1,term1.y-1,term1.w+4,term1.h+2);
    i=32;     
    while(1) { char *p;
               p=termtxt;
               while(*p) {
                   picoTerminalPrintf(&term1,"%c",*(p++));
                   mudelay(50);
               }     
              }

}

void ptk_demo1(void) {
   while (1) {
    demo_draw_lines();
   }
} 
 

