/*
 *  Simple test program -- simplified version of sample test hello.
 * 
 * $Id: main_rtems.c,v 1.3 2000/12/03 12:15:48 tgkamp Exp $
 */

#define VERSION "$Id: main_rtems.c,v 1.3 2000/12/03 12:15:48 tgkamp Exp $"
#define TEST_INIT

#include <bsp.h>
#include <stdio.h>
#include <termios.h>
#include <fcntl.h>
#include <unistd.h>
#include "PTK.h"
rtems_task ptk_demo1(rtems_task_argument ignored);
rtems_task ptk_demo2(rtems_task_argument ignored);
struct picoTerminal term_rtems;


void mudelay(int t){
 int t0;
 t0=Clock_driver_ticks;
 while (Clock_driver_ticks-t0<t/10);
}


rtems_task Init(
  rtems_task_argument ignored
)
{
  int rv;
  int task1_id, task2_id;

  picoInit();
  
  picoSetForeground(NULL,7); 
  picoSetFont(NULL,&font_5x7);
  picoDrawText(NULL,15,470,VERSION);
  picoSetFont(NULL,&font_6x12);
  picoTerminalCreate(&term_rtems,NULL,8,264,52,16 );
  picoDrawRect(NULL,term_rtems.x-1,term_rtems.y-1,term_rtems.w+2,term_rtems.h+2);
  picoTerminalPrintf(&term_rtems,"RTEMS-Idle/Main Task output:\r\n"
                    "RTEMS_MINIMUM_STACK_SIZE: 0x%0x\r\n",
                     RTEMS_MINIMUM_STACK_SIZE
                    );
  
  rv=rtems_task_create(0xaffe   ,10,2048,RTEMS_TIMESLICE,0,&task1_id);
  picoTerminalPrintf(&term_rtems,"Task1: rtems_task_create():");
  picoTerminalPrintf(&term_rtems,
               rv==RTEMS_SUCCESSFUL ? "successfull\r\n":"failed:%d\r\n",
               rv);
  rv=rtems_task_create(0xaffe +1,10,2048,RTEMS_TIMESLICE,0,&task2_id);
  picoTerminalPrintf(&term_rtems,"Task2: rtems_task_create():");
  picoTerminalPrintf(&term_rtems,
               rv==RTEMS_SUCCESSFUL ? "successfull\r\n":"failed:%d\r\n",
               rv);

  picoTerminalPrintf(&term_rtems,"Task 1 ID :%04x\r\n",task1_id);
  picoTerminalPrintf(&term_rtems,"Task 2 ID :%04x\r\n",task2_id);

  rv=rtems_task_start(task1_id,ptk_demo1, 0);
  picoTerminalPrintf(&term_rtems,"Task1: rtems_task_start():");
  picoTerminalPrintf(&term_rtems,
               rv==RTEMS_SUCCESSFUL ? "successfull\r\n":"failed:%d\r\n",
               rv);

  rv=rtems_task_start(task2_id,ptk_demo2,0);
  picoTerminalPrintf(&term_rtems,"Task2: rtems_task_start():");
  picoTerminalPrintf(&term_rtems,
               rv==RTEMS_SUCCESSFUL ? "successfull\r\n":"failed:%d\r\n",
               rv);
  picoTerminalPrintf(&term_rtems,
                     "\n\r"
                     "\r\n\n"
                     " RTEMS  (c) Copyright by OAR Corp (www.oarcorp.com)");
  picoTerminalPrintf(&term_rtems,
                     "\r\n"
                     " picoTK (c) Copyright by Thomas Gallenkamp\r\n"
                     "            (picotk.sourceforge.net)"
                    );

  return;
}

/* configuration information */

#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER

#define CONFIGURE_RTEMS_INIT_TASKS_TABLE

#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
#define CONFIGURE_EXTRA_TASK_STACKS 10000

#define CONFIGURE_INIT
#define CONFIGURE_TICKS_PER_TIMESLICE 1
#define CONFIGURE_MAXIMUM_TASKS 10
#include <confdefs.h>

/* end of file */
