/*
 *  $Id: ppmripper.c,v 1.2 2000/11/12 20:35:34 tgkamp Exp $
 *
 *  ppmripper converts PPMs into picoTK pixmaps
 *
 *  Copyright (c) by Thomas Gallenkamp <tgkamp@users.sourceforge.net>
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include<stdio.h>



void uint8_out(unsigned char x) {
    static int pos=0;
    if (pos==10) {
        printf(",\n");
        pos=0;
    } 
    if (pos==0) {
        printf("     ");
    } else {
        printf(",");
    }
    printf("0x%02x",x);
    pos++;
}

void uint16_out(unsigned short x) {
    uint8_out(x>>8);
    uint8_out(x&0xff);
}
  
   
   

int main(int argc, char **argv) {
 char buf[100];
 int w,h;
 int x,y;

 if (argc<2) {
   fprintf(stderr,"ppmripper <name>\n"
                  "  converts ppm files to compilable C source\n"
          );
   return 1;
 }
 fgets(buf,80,stdin);
 if (strcmp(buf,"P6\n")!=0) {
    fprintf(stderr,"Need P6 PPM file (was:%s).\n",buf);
    return 1;
 }
 do {
  fgets(buf,80,stdin);
 } while(*buf == '#');
 sscanf(buf,"%d %d",&w,&h);
 fgets(buf,80,stdin);
 
 printf(" /*\n"
        "  *  Pixmap data automatically generate by ppmripper\n"
        "  *  -----------------------------------------------\n"
        "  *  $Id: ppmripper.c,v 1.2 2000/11/12 20:35:34 tgkamp Exp $\n"
        "  *\n"
        "  *  Pixmapname:   %s\n"
        "  *  Width:        %d\n"
        "  *  Height:       %d\n"
        "  *  Total Bytes:  %d\n"
        "  */\n", argv[1],w,h,w*h/8);

 printf("unsigned char pixmap_%s[]={\n",argv[1]);
 uint16_out(w);
 uint16_out(h);
 uint8_out(1); /* type */ 
 for(y=0;!feof(stdin) && y<h; y++) {
     int dat;
     dat=0;
  for(x=0; !feof(stdin) && x<w; x++) {
     int pixval;
     
     pixval=(getchar()+getchar()+getchar()>=3*128) ? 0x80:0;
     dat|=pixval>>(x&7);
     if ((x&7)==7) {
         uint8_out(dat);
         dat=0;
     }
  }
  if ( ((x-1)&7)!=7 ) {
      uint8_out(dat);
  }
 }
 printf("\n }; /* end of pixmap %s definition */\n",argv[1]);
 return 0;
}
  
